#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <signal.h>
#include <netdb.h>
extern int h_errno;

#define SCRIPT "/usr/local/bin/tunnel.sh"

/*
 * Possible return values:
 * 0 - shut down by hup, int, term (all ok)
 * 1 - not enough arguments given
 * 2 - hostname does not resolv
 * 3 - ip address is not 4 bytes long
 */

unsigned long dns(char* name)
{    
  struct hostent *host;
  unsigned long ip;

  host = gethostbyname(name);
  if (h_errno)
  {
    return 0;
  }
  if (host->h_length != 4)
  {
   /*
    printf("IP Adresses are expected to use 4 bytes, not %d\n",host->h_length);
    */
    exit(3);
  }
  ip=((host->h_addr_list[0][0] & 0xff) << 24) |
     ((host->h_addr_list[0][1] & 0xff) << 16) |
     ((host->h_addr_list[0][2] & 0xff) <<  8) |
      (host->h_addr_list[0][3] & 0xff) ;
  return ip;
}

void ul2ips(char *retval, unsigned long ip)
{
  sprintf(retval, "%u.%u.%u.%u",
				(unsigned int)(ip >> 24) & 0xff,
				(unsigned int)(ip >> 16) & 0xff,
				(unsigned int)(ip >>  8) & 0xff,
				(unsigned int)(ip      ) & 0xff );
}

void runscript(char* tunnel,unsigned long ip)
{
  char runstring[sizeof(SCRIPT)+21]; // 15(ip)+2(spc)+3(num)+1(nul)
  static char* tnl;

  if(tunnel) tnl=tunnel;
  sprintf(runstring, SCRIPT " %s ", tnl);
  ul2ips(runstring+strlen(runstring), ip);
  system(runstring);
}


void sighandler()
{
  runscript(NULL,0);
  exit(0);
}


int main(int argc, char *argv[])
{
  unsigned long ip=0;
  char *tunnel=argv[1];
  char *hostname=argv[2];

  if(argc != 3)
  {
    return 1;
  }
  ip=dns(hostname);

  if(!ip)
  {
    return 2;
  }

  signal(SIGHUP, sighandler);
  signal(SIGINT, sighandler);
  signal(SIGTERM, sighandler);

  runscript(tunnel,ip);

  for(;;)
  {
    if(ip != dns(hostname))
    {
      ip=dns(hostname);
      runscript(tunnel,0);
      sleep(1);
      runscript(tunnel,ip);
    }
    sleep(60);
  }
  return 0;
}

